#ifndef _DXRDPCMDQUEUE_H
#define _DXRDPCMDQUEUE_H

#include <Windows.h>

#define RDP_CMD_POOL_SIZE  0x100000

struct DxRdpCmd
{
	UINT32 cmd;
	UINT32 cmd_length;
	UINT32 cmd_data[64];
};


class DxRdpCmdQueue
{
public:
	DxRdpCmdQueue(int nPoolSize = RDP_CMD_POOL_SIZE);
	virtual ~DxRdpCmdQueue();

	void				Lock();
	void				Unlock();

	BOOL				IsEmpty() const;
	BOOL				IsFull() const;
	void				clear();

	int					length();
	int					free();

	BOOL				PushData(UINT32 data);

	BOOL				IsCmdReady() const;
	const DxRdpCmd*		PopCmd();

private:
	HANDLE  m_hMutex;
	int		m_nHead;
	int		m_nTail;
	int		m_nLength;
	int		m_nPoolSize;
	UINT32 *m_CmdPool;
};

#endif 